<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ServiceResponse' => '\\StructType\\ServiceResponse',
            'Errors' => '\\StructType\\Errors',
            'Warnings' => '\\StructType\\Warnings',
            'Error' => '\\StructType\\Error',
            'Warning' => '\\StructType\\Warning',
            'CreateExportJobRequest' => '\\StructType\\CreateExportJobRequest',
            'ExportColumns' => '\\StructType\\ExportColumns',
            'ExportFilters' => '\\StructType\\ExportFilters',
            'ExportFilter' => '\\StructType\\ExportFilter',
            'SelectedValues' => '\\StructType\\SelectedValues',
            'DateRange' => '\\StructType\\DateRange',
            'CreateExportJobResponse' => '\\StructType\\CreateExportJobResponse',
            'GetExportJobStatusRequest' => '\\StructType\\GetExportJobStatusRequest',
            'GetExportJobStatusResponse' => '\\StructType\\GetExportJobStatusResponse',
            'CreateSaleOrderRequest' => '\\StructType\\CreateSaleOrderRequest',
            'SaleOrder' => '\\StructType\\SaleOrder',
            'Addresses' => '\\StructType\\Addresses',
            'SaleOrderItems' => '\\StructType\\SaleOrderItems',
            'ShippingProviders' => '\\StructType\\ShippingProviders',
            'SaleOrderItemCombinations' => '\\StructType\\SaleOrderItemCombinations',
            'SaleOrderItemCombination' => '\\StructType\\SaleOrderItemCombination',
            'ShippingProvider' => '\\StructType\\ShippingProvider',
            'AddressRef' => '\\StructType\\AddressRef',
            'Address' => '\\StructType\\Address',
            'SaleOrderItem' => '\\StructType\\SaleOrderItem',
            'ItemDetailFields' => '\\StructType\\ItemDetailFields',
            'CancelSaleOrderRequest' => '\\StructType\\CancelSaleOrderRequest',
            'HoldSaleOrderRequest' => '\\StructType\\HoldSaleOrderRequest',
            'UnholdSaleOrderRequest' => '\\StructType\\UnholdSaleOrderRequest',
            'HoldSaleOrderItemsRequest' => '\\StructType\\HoldSaleOrderItemsRequest',
            'UnholdSaleOrderItemsRequest' => '\\StructType\\UnholdSaleOrderItemsRequest',
            'GetSaleOrderRequest' => '\\StructType\\GetSaleOrderRequest',
            'GetSaleOrderResponse' => '\\StructType\\GetSaleOrderResponse',
            'ShippingPackages' => '\\StructType\\ShippingPackages',
            'ShippingPackage' => '\\StructType\\ShippingPackage',
            'CreateOrEditFacilityItemTypeRequest' => '\\StructType\\CreateOrEditFacilityItemTypeRequest',
            'FacilityItemTypes' => '\\StructType\\FacilityItemTypes',
            'WsFacilityItemType' => '\\StructType\\WsFacilityItemType',
            'CustomFields' => '\\StructType\\CustomFields',
            'CustomField' => '\\StructType\\CustomField',
            'ItemTypeRequest' => '\\StructType\\ItemTypeRequest',
            'Tags' => '\\StructType\\Tags',
            'vendorItemType' => '\\StructType\\VendorItemType',
            'SearchSaleOrderResponse' => '\\StructType\\SearchSaleOrderResponse',
            'SaleOrders' => '\\StructType\\SaleOrders',
            'SearchSaleOrderRequest' => '\\StructType\\SearchSaleOrderRequest',
            'SearchOptions' => '\\StructType\\SearchOptions',
            'EditSaleOrderAddressRequest' => '\\StructType\\EditSaleOrderAddressRequest',
            'SaleOrderAddress' => '\\StructType\\SaleOrderAddress',
            'SaleOrderAddressItems' => '\\StructType\\SaleOrderAddressItems',
            'SaleOrderAddressItem' => '\\StructType\\SaleOrderAddressItem',
            'GetInventorySnapshotRequest' => '\\StructType\\GetInventorySnapshotRequest',
            'ItemTypes' => '\\StructType\\ItemTypes',
            'ItemType' => '\\StructType\\ItemType',
            'GetInventorySnapshotResponse' => '\\StructType\\GetInventorySnapshotResponse',
            'InventorySnapshots' => '\\StructType\\InventorySnapshots',
            'InventorySnapshot' => '\\StructType\\InventorySnapshot',
            'InventoryAdjustmentRequest' => '\\StructType\\InventoryAdjustmentRequest',
            'CreatePurchaseOrderRequest' => '\\StructType\\CreatePurchaseOrderRequest',
            'CreatePurchaseOrderResponse' => '\\StructType\\CreatePurchaseOrderResponse',
            'AddPurchaseOrderItemsRequest' => '\\StructType\\AddPurchaseOrderItemsRequest',
            'PurchaseOrderItems' => '\\StructType\\PurchaseOrderItems',
            'PurchaseOrderItem' => '\\StructType\\PurchaseOrderItem',
            'ApprovePurchaseOrderRequest' => '\\StructType\\ApprovePurchaseOrderRequest',
            'CreateOrEditCategoryRequest' => '\\StructType\\CreateOrEditCategoryRequest',
            'CreateVendorDetailsRequest' => '\\StructType\\CreateVendorDetailsRequest',
            'Contacts' => '\\StructType\\Contacts',
            'Vendor' => '\\StructType\\Vendor',
            'PartyAddress' => '\\StructType\\PartyAddress',
            'PartyContact' => '\\StructType\\PartyContact',
            'VendorAgreement' => '\\StructType\\VendorAgreement',
            'CreateApprovedPurchaseOrderRequest' => '\\StructType\\CreateApprovedPurchaseOrderRequest',
            'CreateApprovedPurchaseOrderResponse' => '\\StructType\\CreateApprovedPurchaseOrderResponse',
            'CreateSaleOrderItemAlternateRequest' => '\\StructType\\CreateSaleOrderItemAlternateRequest',
            'SaleOrderItemAlternates' => '\\StructType\\SaleOrderItemAlternates',
            'SaleOrderItemAlternate' => '\\StructType\\SaleOrderItemAlternate',
            'AcceptSaleOrderItemAlternateRequest' => '\\StructType\\AcceptSaleOrderItemAlternateRequest',
            'GetShippingManifestRequest' => '\\StructType\\GetShippingManifestRequest',
            'GetShippingManifestResponse' => '\\StructType\\GetShippingManifestResponse',
            'ManifestItems' => '\\StructType\\ManifestItems',
            'ManifestItem' => '\\StructType\\ManifestItem',
            'ShippingAddress' => '\\StructType\\ShippingAddress',
            'ShippingPackageType' => '\\StructType\\ShippingPackageType',
            'SearchItemTypesRequest' => '\\StructType\\SearchItemTypesRequest',
            'SearchItemTypesResponse' => '\\StructType\\SearchItemTypesResponse',
            'GetItemTypeDetailRequest' => '\\StructType\\GetItemTypeDetailRequest',
            'GetItemTypeDetailResponse' => '\\StructType\\GetItemTypeDetailResponse',
            'CreateReversePickupRequest' => '\\StructType\\CreateReversePickupRequest',
            'ReversePickupItems' => '\\StructType\\ReversePickupItems',
            'ReversePickupItem' => '\\StructType\\ReversePickupItem',
            'ReversePickupAlternate' => '\\StructType\\ReversePickupAlternate',
            'CreateReversePickupResponse' => '\\StructType\\CreateReversePickupResponse',
            'SaleOrderItemCodes' => '\\StructType\\SaleOrderItemCodes',
            'EditSaleOrderMetadataRequest' => '\\StructType\\EditSaleOrderMetadataRequest',
            'CreateCustomerRequest' => '\\StructType\\CreateCustomerRequest',
            'EditCustomerRequest' => '\\StructType\\EditCustomerRequest',
            'Customer' => '\\StructType\\Customer',
            'UpdateTrackingStatusRequest' => '\\StructType\\UpdateTrackingStatusRequest',
            'ClosePurchaseOrderRequest' => '\\StructType\\ClosePurchaseOrderRequest',
            'GetBackOrderItemsRequest' => '\\StructType\\GetBackOrderItemsRequest',
            'BackOrderItem' => '\\StructType\\BackOrderItem',
            'SaleOrderItemDTO' => '\\StructType\\SaleOrderItemDTO',
            'ItemDetail' => '\\StructType\\ItemDetail',
            'InflowReceiptItem' => '\\StructType\\InflowReceiptItem',
            'PurchaseOrder' => '\\StructType\\PurchaseOrder',
            'InflowReceipt' => '\\StructType\\InflowReceipt',
            'InflowReceiptItems' => '\\StructType\\InflowReceiptItems',
            'GetBackOrderItemsResponse' => '\\StructType\\GetBackOrderItemsResponse',
            'BackOrderItems' => '\\StructType\\BackOrderItems',
            'GetItemDetailRequest' => '\\StructType\\GetItemDetailRequest',
            'GetItemDetailResponse' => '\\StructType\\GetItemDetailResponse',
            'EditSaleOrderItemMetadataRequest' => '\\StructType\\EditSaleOrderItemMetadataRequest',
            'GetPurchaseOrdersRequest' => '\\StructType\\GetPurchaseOrdersRequest',
            'ApprovedDateRange' => '\\StructType\\ApprovedDateRange',
            'CreatedDateRange' => '\\StructType\\CreatedDateRange',
            'GetPurchaseOrdersResponse' => '\\StructType\\GetPurchaseOrdersResponse',
            'PurchaseOrders' => '\\StructType\\PurchaseOrders',
            'GetPurchaseOrderDetailRequest' => '\\StructType\\GetPurchaseOrderDetailRequest',
            'GetPurchaseOrderDetailResponse' => '\\StructType\\GetPurchaseOrderDetailResponse',
            'GetInflowReceiptsRequest' => '\\StructType\\GetInflowReceiptsRequest',
            'GetInflowReceiptsResponse' => '\\StructType\\GetInflowReceiptsResponse',
            'InflowReceipts' => '\\StructType\\InflowReceipts',
            'GetInflowReceiptDetailRequest' => '\\StructType\\GetInflowReceiptDetailRequest',
            'GetInflowReceiptDetailResponse' => '\\StructType\\GetInflowReceiptDetailResponse',
            'EditScriptConfigRequest' => '\\StructType\\EditScriptConfigRequest',
            'GetServiceabilityRequest' => '\\StructType\\GetServiceabilityRequest',
            'GetServiceabilityResponse' => '\\StructType\\GetServiceabilityResponse',
            'Facilities' => '\\StructType\\Facilities',
            'Facility' => '\\StructType\\Facility',
            'EditVendorDetailsRequest' => '\\StructType\\EditVendorDetailsRequest',
            'AddOrEditItemLabelsRequest' => '\\StructType\\AddOrEditItemLabelsRequest',
            'ItemCodes' => '\\StructType\\ItemCodes',
            'WsGatePass' => '\\StructType\\WsGatePass',
            'EditGatePassRequest' => '\\StructType\\EditGatePassRequest',
            'EditGatePassResponse' => '\\StructType\\EditGatePassResponse',
            'GetVendorItemTypesRequest' => '\\StructType\\GetVendorItemTypesRequest',
            'GetVendorItemTypesResponse' => '\\StructType\\GetVendorItemTypesResponse',
            'VendorItemTypes' => '\\StructType\\VendorItemTypes',
            'VendorItemType' => '\\StructType\\VendorItemType_1',
            'DispatchShippingPackageRequest' => '\\StructType\\DispatchShippingPackageRequest',
            'DispatchShippingPackageResponse' => '\\StructType\\DispatchShippingPackageResponse',
            'SplitShippingPackageRequest' => '\\StructType\\SplitShippingPackageRequest',
            'SplitSaleOrderItems' => '\\StructType\\SplitSaleOrderItems',
            'SplitSaleOrderItem' => '\\StructType\\SplitSaleOrderItem',
            'SplitShippingPackageResponse' => '\\StructType\\SplitShippingPackageResponse',
            'SplittedShippingPackages' => '\\StructType\\SplittedShippingPackages',
            'ReceiveReversePickupFromRetailResponse' => '\\StructType\\ReceiveReversePickupFromRetailResponse',
            'RetailReversePickupItem' => '\\StructType\\RetailReversePickupItem',
            'ReceiveReversePickupFromRetailRequest' => '\\StructType\\ReceiveReversePickupFromRetailRequest',
            'WsPartyAddress' => '\\StructType\\WsPartyAddress',
            'WsFacility' => '\\StructType\\WsFacility',
            'PartyContacts' => '\\StructType\\PartyContacts',
            'WsFacilityCreate' => '\\StructType\\WsFacilityCreate',
            'WsSequence' => '\\StructType\\WsSequence',
            'CreateFacilityRequest' => '\\StructType\\CreateFacilityRequest',
            'EditFacilityRequest' => '\\StructType\\EditFacilityRequest',
            'PartyAddressDTO' => '\\StructType\\PartyAddressDTO',
            'FacilityDTO' => '\\StructType\\FacilityDTO',
            'CreateFacilityResponse' => '\\StructType\\CreateFacilityResponse',
            'EditFacilityResponse' => '\\StructType\\EditFacilityResponse',
            'VerifySaleOrderRequest' => '\\StructType\\VerifySaleOrderRequest',
            'MarkItemDamagedOutboundQCRequest' => '\\StructType\\MarkItemDamagedOutboundQCRequest',
            'CreateInvoiceAndAllocateShippingProviderRequest' => '\\StructType\\CreateInvoiceAndAllocateShippingProviderRequest',
            'CreateInvoiceAndAllocateShippingProviderResponse' => '\\StructType\\CreateInvoiceAndAllocateShippingProviderResponse',
            'CreateASNRequest' => '\\StructType\\CreateASNRequest',
            'AsnItems' => '\\StructType\\AsnItems',
            'AsnItem' => '\\StructType\\AsnItem',
            'CreateASNResponse' => '\\StructType\\CreateASNResponse',
            'SetSaleOrderPriorityRequest' => '\\StructType\\SetSaleOrderPriorityRequest',
            'SetSaleOrderPriorityResponse' => '\\StructType\\SetSaleOrderPriorityResponse',
            'CreateGatePassRequest' => '\\StructType\\CreateGatePassRequest',
            'CreateGatePassResponse' => '\\StructType\\CreateGatePassResponse',
            'AddItemToGatePassRequest' => '\\StructType\\AddItemToGatePassRequest',
            'AddItemToGatePassResponse' => '\\StructType\\AddItemToGatePassResponse',
            'CompleteGatePassRequest' => '\\StructType\\CompleteGatePassRequest',
            'CompleteGatePassResponse' => '\\StructType\\CompleteGatePassResponse',
            'WsInflowItemType' => '\\StructType\\WsInflowItemType',
            'AutoCompletePutawayRequest' => '\\StructType\\AutoCompletePutawayRequest',
            'InflowItemTypes' => '\\StructType\\InflowItemTypes',
            'AutoCompletePutawayResponse' => '\\StructType\\AutoCompletePutawayResponse',
            'PickShippingPackageRequest' => '\\StructType\\PickShippingPackageRequest',
            'PickShippingPackageResponse' => '\\StructType\\PickShippingPackageResponse',
            'UnblockSaleOrderItemsInventoryRequest' => '\\StructType\\UnblockSaleOrderItemsInventoryRequest',
            'UnblockSaleOrderItemsInventoryResponse' => '\\StructType\\UnblockSaleOrderItemsInventoryResponse',
            'ModifyPacketSaleOrderRequest' => '\\StructType\\ModifyPacketSaleOrderRequest',
            'ModifyPacketSaleOrderResponse' => '\\StructType\\ModifyPacketSaleOrderResponse',
            'GetItemTypeInventoryRequest' => '\\StructType\\GetItemTypeInventoryRequest',
            'GetItemTypeInventoryResponse' => '\\StructType\\GetItemTypeInventoryResponse',
            'ItemTypeInventoryDetails' => '\\StructType\\ItemTypeInventoryDetails',
            'ItemTypeInventory' => '\\StructType\\ItemTypeInventory',
            'GetTaxTypeConfigurationRequest' => '\\StructType\\GetTaxTypeConfigurationRequest',
            'GetTaxTypeConfigurationResponse' => '\\StructType\\GetTaxTypeConfigurationResponse',
            'TaxTypeConfigurations' => '\\StructType\\TaxTypeConfigurations',
            'TaxTypeConfiguration' => '\\StructType\\TaxTypeConfiguration',
            'GRN' => '\\StructType\\GRN',
            'CreateInflowReceiptRequest' => '\\StructType\\CreateInflowReceiptRequest',
            'CreateInflowReceiptResponse' => '\\StructType\\CreateInflowReceiptResponse',
            'AddItemToInflowReceiptRequest' => '\\StructType\\AddItemToInflowReceiptRequest',
            'AddItemToInflowReceiptResponse' => '\\StructType\\AddItemToInflowReceiptResponse',
            'AddShipmentsToBatchRequest' => '\\StructType\\AddShipmentsToBatchRequest',
            'ShippingPackageCodes' => '\\StructType\\ShippingPackageCodes',
            'AddShipmentsToBatchResponse' => '\\StructType\\AddShipmentsToBatchResponse',
            'CreateVendorCreditInvoiceResponse' => '\\StructType\\CreateVendorCreditInvoiceResponse',
            'CreateVendorCreditInvoiceRequest' => '\\StructType\\CreateVendorCreditInvoiceRequest',
            'VendorInvoice' => '\\StructType\\VendorInvoice',
            'AddEditVendorInvoiceItemResponse' => '\\StructType\\AddEditVendorInvoiceItemResponse',
            'AddEditVendorInvoiceItemRequest' => '\\StructType\\AddEditVendorInvoiceItemRequest',
            'VendorInvoiceItems' => '\\StructType\\VendorInvoiceItems',
            'VendorInvoiceItem' => '\\StructType\\VendorInvoiceItem',
            'WsShippingBox' => '\\StructType\\WsShippingBox',
            'EditShippingPackageRequest' => '\\StructType\\EditShippingPackageRequest',
            'EditShippingPackageResponse' => '\\StructType\\EditShippingPackageResponse',
        );
    }
}
