<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateInflowReceiptResponse StructType
 * @subpackage Structs
 */
class CreateInflowReceiptResponse extends AbstractStructBase
{
    /**
     * The Successful
     * @var bool
     */
    public $Successful;
    /**
     * The Errors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Errors
     */
    public $Errors;
    /**
     * The Warnings
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Warnings
     */
    public $Warnings;
    /**
     * The InflowReceiptCode
     * @var string
     */
    public $InflowReceiptCode;
    /**
     * Constructor method for CreateInflowReceiptResponse
     * @uses CreateInflowReceiptResponse::setSuccessful()
     * @uses CreateInflowReceiptResponse::setErrors()
     * @uses CreateInflowReceiptResponse::setWarnings()
     * @uses CreateInflowReceiptResponse::setInflowReceiptCode()
     * @param bool $successful
     * @param \StructType\Errors $errors
     * @param \StructType\Warnings $warnings
     * @param string $inflowReceiptCode
     */
    public function __construct($successful = null, \StructType\Errors $errors = null, \StructType\Warnings $warnings = null, $inflowReceiptCode = null)
    {
        $this
            ->setSuccessful($successful)
            ->setErrors($errors)
            ->setWarnings($warnings)
            ->setInflowReceiptCode($inflowReceiptCode);
    }
    /**
     * Get Successful value
     * @return bool|null
     */
    public function getSuccessful()
    {
        return $this->Successful;
    }
    /**
     * Set Successful value
     * @param bool $successful
     * @return \StructType\CreateInflowReceiptResponse
     */
    public function setSuccessful($successful = null)
    {
        // validation for constraint: boolean
        if (!is_null($successful) && !is_bool($successful)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($successful, true), gettype($successful)), __LINE__);
        }
        $this->Successful = $successful;
        return $this;
    }
    /**
     * Get Errors value
     * @return \StructType\Errors|null
     */
    public function getErrors()
    {
        return $this->Errors;
    }
    /**
     * Set Errors value
     * @param \StructType\Errors $errors
     * @return \StructType\CreateInflowReceiptResponse
     */
    public function setErrors(\StructType\Errors $errors = null)
    {
        $this->Errors = $errors;
        return $this;
    }
    /**
     * Get Warnings value
     * @return \StructType\Warnings|null
     */
    public function getWarnings()
    {
        return $this->Warnings;
    }
    /**
     * Set Warnings value
     * @param \StructType\Warnings $warnings
     * @return \StructType\CreateInflowReceiptResponse
     */
    public function setWarnings(\StructType\Warnings $warnings = null)
    {
        $this->Warnings = $warnings;
        return $this;
    }
    /**
     * Get InflowReceiptCode value
     * @return string|null
     */
    public function getInflowReceiptCode()
    {
        return $this->InflowReceiptCode;
    }
    /**
     * Set InflowReceiptCode value
     * @param string $inflowReceiptCode
     * @return \StructType\CreateInflowReceiptResponse
     */
    public function setInflowReceiptCode($inflowReceiptCode = null)
    {
        // validation for constraint: string
        if (!is_null($inflowReceiptCode) && !is_string($inflowReceiptCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($inflowReceiptCode, true), gettype($inflowReceiptCode)), __LINE__);
        }
        $this->InflowReceiptCode = $inflowReceiptCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateInflowReceiptResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
