<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateVendorCreditInvoiceResponse StructType
 * @subpackage Structs
 */
class CreateVendorCreditInvoiceResponse extends AbstractStructBase
{
    /**
     * The Successful
     * @var bool
     */
    public $Successful;
    /**
     * The Errors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Errors
     */
    public $Errors;
    /**
     * The Warnings
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Warnings
     */
    public $Warnings;
    /**
     * The VendorInvoiceCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $VendorInvoiceCode;
    /**
     * Constructor method for CreateVendorCreditInvoiceResponse
     * @uses CreateVendorCreditInvoiceResponse::setSuccessful()
     * @uses CreateVendorCreditInvoiceResponse::setErrors()
     * @uses CreateVendorCreditInvoiceResponse::setWarnings()
     * @uses CreateVendorCreditInvoiceResponse::setVendorInvoiceCode()
     * @param bool $successful
     * @param \StructType\Errors $errors
     * @param \StructType\Warnings $warnings
     * @param string $vendorInvoiceCode
     */
    public function __construct($successful = null, \StructType\Errors $errors = null, \StructType\Warnings $warnings = null, $vendorInvoiceCode = null)
    {
        $this
            ->setSuccessful($successful)
            ->setErrors($errors)
            ->setWarnings($warnings)
            ->setVendorInvoiceCode($vendorInvoiceCode);
    }
    /**
     * Get Successful value
     * @return bool|null
     */
    public function getSuccessful()
    {
        return $this->Successful;
    }
    /**
     * Set Successful value
     * @param bool $successful
     * @return \StructType\CreateVendorCreditInvoiceResponse
     */
    public function setSuccessful($successful = null)
    {
        // validation for constraint: boolean
        if (!is_null($successful) && !is_bool($successful)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($successful, true), gettype($successful)), __LINE__);
        }
        $this->Successful = $successful;
        return $this;
    }
    /**
     * Get Errors value
     * @return \StructType\Errors|null
     */
    public function getErrors()
    {
        return $this->Errors;
    }
    /**
     * Set Errors value
     * @param \StructType\Errors $errors
     * @return \StructType\CreateVendorCreditInvoiceResponse
     */
    public function setErrors(\StructType\Errors $errors = null)
    {
        $this->Errors = $errors;
        return $this;
    }
    /**
     * Get Warnings value
     * @return \StructType\Warnings|null
     */
    public function getWarnings()
    {
        return $this->Warnings;
    }
    /**
     * Set Warnings value
     * @param \StructType\Warnings $warnings
     * @return \StructType\CreateVendorCreditInvoiceResponse
     */
    public function setWarnings(\StructType\Warnings $warnings = null)
    {
        $this->Warnings = $warnings;
        return $this;
    }
    /**
     * Get VendorInvoiceCode value
     * @return string|null
     */
    public function getVendorInvoiceCode()
    {
        return $this->VendorInvoiceCode;
    }
    /**
     * Set VendorInvoiceCode value
     * @param string $vendorInvoiceCode
     * @return \StructType\CreateVendorCreditInvoiceResponse
     */
    public function setVendorInvoiceCode($vendorInvoiceCode = null)
    {
        // validation for constraint: string
        if (!is_null($vendorInvoiceCode) && !is_string($vendorInvoiceCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vendorInvoiceCode, true), gettype($vendorInvoiceCode)), __LINE__);
        }
        $this->VendorInvoiceCode = $vendorInvoiceCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateVendorCreditInvoiceResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
