<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EditFacilityRequest StructType
 * @subpackage Structs
 */
class EditFacilityRequest extends AbstractStructBase
{
    /**
     * The RetailInvoiceSequence
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\WsSequence
     */
    public $RetailInvoiceSequence;
    /**
     * The TaxInvoiceSequence
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\WsSequence
     */
    public $TaxInvoiceSequence;
    /**
     * The WsFacility
     * @var \StructType\WsFacility
     */
    public $WsFacility;
    /**
     * Constructor method for EditFacilityRequest
     * @uses EditFacilityRequest::setRetailInvoiceSequence()
     * @uses EditFacilityRequest::setTaxInvoiceSequence()
     * @uses EditFacilityRequest::setWsFacility()
     * @param \StructType\WsSequence $retailInvoiceSequence
     * @param \StructType\WsSequence $taxInvoiceSequence
     * @param \StructType\WsFacility $wsFacility
     */
    public function __construct(\StructType\WsSequence $retailInvoiceSequence = null, \StructType\WsSequence $taxInvoiceSequence = null, \StructType\WsFacility $wsFacility = null)
    {
        $this
            ->setRetailInvoiceSequence($retailInvoiceSequence)
            ->setTaxInvoiceSequence($taxInvoiceSequence)
            ->setWsFacility($wsFacility);
    }
    /**
     * Get RetailInvoiceSequence value
     * @return \StructType\WsSequence|null
     */
    public function getRetailInvoiceSequence()
    {
        return $this->RetailInvoiceSequence;
    }
    /**
     * Set RetailInvoiceSequence value
     * @param \StructType\WsSequence $retailInvoiceSequence
     * @return \StructType\EditFacilityRequest
     */
    public function setRetailInvoiceSequence(\StructType\WsSequence $retailInvoiceSequence = null)
    {
        $this->RetailInvoiceSequence = $retailInvoiceSequence;
        return $this;
    }
    /**
     * Get TaxInvoiceSequence value
     * @return \StructType\WsSequence|null
     */
    public function getTaxInvoiceSequence()
    {
        return $this->TaxInvoiceSequence;
    }
    /**
     * Set TaxInvoiceSequence value
     * @param \StructType\WsSequence $taxInvoiceSequence
     * @return \StructType\EditFacilityRequest
     */
    public function setTaxInvoiceSequence(\StructType\WsSequence $taxInvoiceSequence = null)
    {
        $this->TaxInvoiceSequence = $taxInvoiceSequence;
        return $this;
    }
    /**
     * Get WsFacility value
     * @return \StructType\WsFacility|null
     */
    public function getWsFacility()
    {
        return $this->WsFacility;
    }
    /**
     * Set WsFacility value
     * @param \StructType\WsFacility $wsFacility
     * @return \StructType\EditFacilityRequest
     */
    public function setWsFacility(\StructType\WsFacility $wsFacility = null)
    {
        $this->WsFacility = $wsFacility;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EditFacilityRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
