<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InflowItemTypes StructType
 * @subpackage Structs
 */
class InflowItemTypes extends AbstractStructBase
{
    /**
     * The InflowItemType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\WsInflowItemType[]
     */
    public $InflowItemType;
    /**
     * Constructor method for InflowItemTypes
     * @uses InflowItemTypes::setInflowItemType()
     * @param \StructType\WsInflowItemType[] $inflowItemType
     */
    public function __construct(array $inflowItemType = array())
    {
        $this
            ->setInflowItemType($inflowItemType);
    }
    /**
     * Get InflowItemType value
     * @return \StructType\WsInflowItemType[]|null
     */
    public function getInflowItemType()
    {
        return $this->InflowItemType;
    }
    /**
     * This method is responsible for validating the values passed to the setInflowItemType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInflowItemType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInflowItemTypeForArrayConstraintsFromSetInflowItemType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $inflowItemTypesInflowItemTypeItem) {
            // validation for constraint: itemType
            if (!$inflowItemTypesInflowItemTypeItem instanceof \StructType\WsInflowItemType) {
                $invalidValues[] = is_object($inflowItemTypesInflowItemTypeItem) ? get_class($inflowItemTypesInflowItemTypeItem) : sprintf('%s(%s)', gettype($inflowItemTypesInflowItemTypeItem), var_export($inflowItemTypesInflowItemTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InflowItemType property can only contain items of type \StructType\WsInflowItemType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InflowItemType value
     * @throws \InvalidArgumentException
     * @param \StructType\WsInflowItemType[] $inflowItemType
     * @return \StructType\InflowItemTypes
     */
    public function setInflowItemType(array $inflowItemType = array())
    {
        // validation for constraint: array
        if ('' !== ($inflowItemTypeArrayErrorMessage = self::validateInflowItemTypeForArrayConstraintsFromSetInflowItemType($inflowItemType))) {
            throw new \InvalidArgumentException($inflowItemTypeArrayErrorMessage, __LINE__);
        }
        $this->InflowItemType = $inflowItemType;
        return $this;
    }
    /**
     * Add item to InflowItemType value
     * @throws \InvalidArgumentException
     * @param \StructType\WsInflowItemType $item
     * @return \StructType\InflowItemTypes
     */
    public function addToInflowItemType(\StructType\WsInflowItemType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WsInflowItemType) {
            throw new \InvalidArgumentException(sprintf('The InflowItemType property can only contain items of type \StructType\WsInflowItemType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InflowItemType[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InflowItemTypes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
