<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PartyContacts StructType
 * @subpackage Structs
 */
class PartyContacts extends AbstractStructBase
{
    /**
     * The PartyContact
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\PartyContact[]
     */
    public $PartyContact;
    /**
     * Constructor method for PartyContacts
     * @uses PartyContacts::setPartyContact()
     * @param \StructType\PartyContact[] $partyContact
     */
    public function __construct(array $partyContact = array())
    {
        $this
            ->setPartyContact($partyContact);
    }
    /**
     * Get PartyContact value
     * @return \StructType\PartyContact[]|null
     */
    public function getPartyContact()
    {
        return $this->PartyContact;
    }
    /**
     * This method is responsible for validating the values passed to the setPartyContact method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPartyContact method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePartyContactForArrayConstraintsFromSetPartyContact(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $partyContactsPartyContactItem) {
            // validation for constraint: itemType
            if (!$partyContactsPartyContactItem instanceof \StructType\PartyContact) {
                $invalidValues[] = is_object($partyContactsPartyContactItem) ? get_class($partyContactsPartyContactItem) : sprintf('%s(%s)', gettype($partyContactsPartyContactItem), var_export($partyContactsPartyContactItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PartyContact property can only contain items of type \StructType\PartyContact, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PartyContact value
     * @throws \InvalidArgumentException
     * @param \StructType\PartyContact[] $partyContact
     * @return \StructType\PartyContacts
     */
    public function setPartyContact(array $partyContact = array())
    {
        // validation for constraint: array
        if ('' !== ($partyContactArrayErrorMessage = self::validatePartyContactForArrayConstraintsFromSetPartyContact($partyContact))) {
            throw new \InvalidArgumentException($partyContactArrayErrorMessage, __LINE__);
        }
        $this->PartyContact = $partyContact;
        return $this;
    }
    /**
     * Add item to PartyContact value
     * @throws \InvalidArgumentException
     * @param \StructType\PartyContact $item
     * @return \StructType\PartyContacts
     */
    public function addToPartyContact(\StructType\PartyContact $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PartyContact) {
            throw new \InvalidArgumentException(sprintf('The PartyContact property can only contain items of type \StructType\PartyContact, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PartyContact[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PartyContacts
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
