<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PurchaseOrderItems StructType
 * @subpackage Structs
 */
class PurchaseOrderItems extends AbstractStructBase
{
    /**
     * The PurchaseOrderItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\PurchaseOrderItem[]
     */
    public $PurchaseOrderItem;
    /**
     * Constructor method for PurchaseOrderItems
     * @uses PurchaseOrderItems::setPurchaseOrderItem()
     * @param \StructType\PurchaseOrderItem[] $purchaseOrderItem
     */
    public function __construct(array $purchaseOrderItem = array())
    {
        $this
            ->setPurchaseOrderItem($purchaseOrderItem);
    }
    /**
     * Get PurchaseOrderItem value
     * @return \StructType\PurchaseOrderItem[]|null
     */
    public function getPurchaseOrderItem()
    {
        return $this->PurchaseOrderItem;
    }
    /**
     * This method is responsible for validating the values passed to the setPurchaseOrderItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPurchaseOrderItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePurchaseOrderItemForArrayConstraintsFromSetPurchaseOrderItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $purchaseOrderItemsPurchaseOrderItemItem) {
            // validation for constraint: itemType
            if (!$purchaseOrderItemsPurchaseOrderItemItem instanceof \StructType\PurchaseOrderItem) {
                $invalidValues[] = is_object($purchaseOrderItemsPurchaseOrderItemItem) ? get_class($purchaseOrderItemsPurchaseOrderItemItem) : sprintf('%s(%s)', gettype($purchaseOrderItemsPurchaseOrderItemItem), var_export($purchaseOrderItemsPurchaseOrderItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PurchaseOrderItem property can only contain items of type \StructType\PurchaseOrderItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PurchaseOrderItem value
     * @throws \InvalidArgumentException
     * @param \StructType\PurchaseOrderItem[] $purchaseOrderItem
     * @return \StructType\PurchaseOrderItems
     */
    public function setPurchaseOrderItem(array $purchaseOrderItem = array())
    {
        // validation for constraint: array
        if ('' !== ($purchaseOrderItemArrayErrorMessage = self::validatePurchaseOrderItemForArrayConstraintsFromSetPurchaseOrderItem($purchaseOrderItem))) {
            throw new \InvalidArgumentException($purchaseOrderItemArrayErrorMessage, __LINE__);
        }
        $this->PurchaseOrderItem = $purchaseOrderItem;
        return $this;
    }
    /**
     * Add item to PurchaseOrderItem value
     * @throws \InvalidArgumentException
     * @param \StructType\PurchaseOrderItem $item
     * @return \StructType\PurchaseOrderItems
     */
    public function addToPurchaseOrderItem(\StructType\PurchaseOrderItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PurchaseOrderItem) {
            throw new \InvalidArgumentException(sprintf('The PurchaseOrderItem property can only contain items of type \StructType\PurchaseOrderItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PurchaseOrderItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PurchaseOrderItems
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
