<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VendorItemTypes StructType
 * @subpackage Structs
 */
class VendorItemTypes extends AbstractStructBase
{
    /**
     * The VendorItemType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\VendorItemType_1[]
     */
    public $VendorItemType;
    /**
     * Constructor method for VendorItemTypes
     * @uses VendorItemTypes::setVendorItemType()
     * @param \StructType\VendorItemType_1[] $vendorItemType
     */
    public function __construct(array $vendorItemType = array())
    {
        $this
            ->setVendorItemType($vendorItemType);
    }
    /**
     * Get VendorItemType value
     * @return \StructType\VendorItemType_1[]|null
     */
    public function getVendorItemType()
    {
        return $this->VendorItemType;
    }
    /**
     * This method is responsible for validating the values passed to the setVendorItemType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVendorItemType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVendorItemTypeForArrayConstraintsFromSetVendorItemType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $vendorItemTypesVendorItemTypeItem) {
            // validation for constraint: itemType
            if (!$vendorItemTypesVendorItemTypeItem instanceof \StructType\VendorItemType_1) {
                $invalidValues[] = is_object($vendorItemTypesVendorItemTypeItem) ? get_class($vendorItemTypesVendorItemTypeItem) : sprintf('%s(%s)', gettype($vendorItemTypesVendorItemTypeItem), var_export($vendorItemTypesVendorItemTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VendorItemType property can only contain items of type \StructType\VendorItemType_1, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VendorItemType value
     * @throws \InvalidArgumentException
     * @param \StructType\VendorItemType_1[] $vendorItemType
     * @return \StructType\VendorItemTypes
     */
    public function setVendorItemType(array $vendorItemType = array())
    {
        // validation for constraint: array
        if ('' !== ($vendorItemTypeArrayErrorMessage = self::validateVendorItemTypeForArrayConstraintsFromSetVendorItemType($vendorItemType))) {
            throw new \InvalidArgumentException($vendorItemTypeArrayErrorMessage, __LINE__);
        }
        $this->VendorItemType = $vendorItemType;
        return $this;
    }
    /**
     * Add item to VendorItemType value
     * @throws \InvalidArgumentException
     * @param \StructType\VendorItemType_1 $item
     * @return \StructType\VendorItemTypes
     */
    public function addToVendorItemType(\StructType\VendorItemType_1 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VendorItemType_1) {
            throw new \InvalidArgumentException(sprintf('The VendorItemType property can only contain items of type \StructType\VendorItemType_1, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VendorItemType[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VendorItemTypes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
